#ifndef CONFIG_H
	#define CONFIG_H

	#define MAX_CONFIG_LINE_LEN 50

	#include <stdio.h>
	#include <map>
	#include <string>
	#include "../Common.h"

	class Config {
		public:
			//Constructor reads from input config file and populates strMap hash map
			Config(const char *configInputFile);
			~Config();

			//output strMap config settings to a file or to the console
			void writeSettingsToFile(const char *configOutputFile);
			void writeSettingsToConsole();

			//add a NEW field/value pair into strMap
			void addStrField(const string &field, const string &value);
			
			//setter methods
			void updateField(const string &field, const string &value);
			void updateField(const string &field, const uint &value);
			
			//getter methods
			string getStr(const string &field) const;
			uint getUInt(const string &field) const;

	private:
		//hash map for config settings (field/value pairs)
		map<string,string> strMap;

		void parseSettingsConfig(FILE *inputFile);		
	};
#endif
