#ifndef MEMORYCNTRL_H
	#define MEMORYCNTRL_H

	#include "Node.h"	

	enum MemoryCntrlInsnType {
		MCIT_SEND,
		MCIT_WAIT
	};

	struct MemoryCntrlInsn {
		MemoryCntrlInsnType t;
		uint output1;
		uint input1;
	};

	class MemoryCntrl : public Node {
		private:
			// MemoryCntrl Parameters
			uint NumberPacketSendPerCycle;
			uint NumberPacketReceivePerCycle;

			// Instance Data
			uint dataSent;
			uint dataReceived;
			set<uint> waitForData;
			set<uint> availableData;
			vector<Packet> pendingPackets;
			deque<MemoryCntrlInsn> instructions;

		protected:
			bool send(set<Node*>& usedLinks, Packet p);	

		public:
			// Constructors
			MemoryCntrl();			
			~MemoryCntrl();

			void preStep();
			void step();

			bool receive(Packet p);

			void setupNode(Config* c, uint nodeId);

			// Add an instruction for the node to process
			void addInstruction(string insn);

			// Return if the node has finished all its instruction or not
			bool isCompleted();

			// Reset counters
			void resetCounters();

			// print stats
			void printStat();
	};
#endif