#ifndef SIMULATOR_H
	#define SIMULATOR_H

	#include "../Common.h"
	#include "../Config/Config.h"
	#include "SimpleNode.h"
	#include "MemoryCntrl.h"

	enum DijkstraQueueState {
		INQUEUE,
		NOTINQUEUE
	};

	struct DijkstraInfo {
		uint *minDistArray;
		uint *previousNodeIdArray;
	};

	class Simulator {
		private:
			Config *config;
			MemoryCntrl memCntrl;
			SimpleNode *simpleNodes;			
			Node** nodes;
			uint numOfNodes;			
			
			void setupMemCntrlNeighbours();
			void setupMeshNeighbours(uint startId, uint numOfNodes);
			void setupTorusNeighbours(uint startId, uint numOfNodes);
			void setupTreeNeighbours(uint startId, uint numOfNodes);

			void setupRoutingTable();			

			uint getNodeIdWithSmallestDist(uint *minDistArray, DijkstraQueueState *nodeQueueState);
			void Dijkstra(Node *src, DijkstraInfo &dInfo);

		public:
			Simulator(char *inputConfig);
			~Simulator();
			
			bool setupTopology();
			void readTrafficFile();
			void runSimulation();
	};
#endif
