#include <iostream>
#include <fstream>
#include <math.h>
#include <assert.h>
using namespace std;

#include "Parser.h"

//Reads a Sudoku puzzle from a file into a 1D array.
//The function dynamically allocates memory for the array.
uint *ReadSudokuFromFile(char* fileName, uint& size) {
	ifstream inputFile(fileName);
	assert(inputFile.is_open());

	inputFile >> size;

	double boxSize = sqrt(size);
	assert(boxSize == floor(boxSize));

	uint *puzzle = new uint[size*size];

	for (uint i=0; i<size*size; i++)
		inputFile >> puzzle[i];

	inputFile.close();
	return puzzle;
}

//Writes a Sudoku puzzle from a 1D array into a file.
//Doesn't deallocate the 1D array before the function returns.
void WriteSudokuToFile(char* fileName, uint* puzzle, uint size) {
	assert(puzzle != NULL);

	ofstream outputFile(fileName);
	assert(outputFile.is_open());

	outputFile << size << endl;

	for (uint i=0; i<size; i++) {
		for (uint j=0; j<size; j++)
			outputFile << puzzle[i*size+j] << " ";
		outputFile << endl;
	}

	outputFile.close();
}

void WriteSudokuToConsole(uint* puzzle, uint size) {
	assert(puzzle != NULL);

	for (uint i=0; i<size; i++) {
		for (uint j=0; j<size; j++)
			cout << puzzle[i*size+j] << " ";
		cout << endl;
	}
}
