#include <iostream>
using namespace std;

#include "SerialSolver.h"

/**
 * Usage 1: Without the output Insn File
 *     Params: <input puzzle>
 * Result: No output insn file is created; puzzle is still solved.
 *
 * Usage 2: With the output Insn File
 *     Params: <input puzzle> <out Insn File>
 */
int main(int argc, char **argv) {
	assert(argc == 2 || argc == 3);
	
	char *outputInsnFilePath = NULL;
	if (argc == 3)
		outputInsnFilePath = argv[2];

	SudokuSerialSolver sudoku(argv[1], outputInsnFilePath);
	sudoku.printPuzzleToScreen();
	
	sudoku.solve();
	
	cout << "\nSolved Puzzle:\n";
	sudoku.printPuzzleToScreen();
		
	uint errRow, errCol;
	bool retVal = sudoku.verify(errRow, errCol);

	if (retVal) cout << "Validation successful!" << endl;
	else cout << "Validation failure @ (" << errRow << "," << errCol << ") !!!" << endl;

	return 0;
}
